# TIMSDK

## 最新版本 4.5.15 @2019.08.30

### SDK

**通用变更点**

- 优化海外用户发送文件消息的速度
- 修复消息撤回后通过 getLastMessage 获取该消息状态不对的问题；修复撤回监听多次回调的问题
- 后台修复群成员被禁言后，退群再进群获取禁言时间异常问题
- 修复 msg 时间主动修改后，savemsg 的时候时间不生效的问题
- 修复偶现登录无回调的问题
- 修复被撤回群消息的rand和timestamp为空的问题
- 修复登出状态下回调userSig过期的问题；修复登出状态下仍然断网重连的问题

**Android 平台**

- 后台支持Android端的FCM推送
- 修复获取指定的好友分组，传入 null 时报错问题
- 修复特定场景下 checkEquals 接口崩溃问题

**Windows平台**

- MessageLocator新增unique_id 字段
- Windows版本支持64位
- 跨平台库新增用户资料接口、关系链接口

### TUIKit & Demo

**iOS**

- 新增自定义消息发送
- 新增C2C已读回执
- 新增语音未播放红点显示

**Android**

- 修改部分场景下demo内存泄漏的问题
- 修改某些场景下的崩溃问题
- 修改定制消息颜色不对的问题
- 修改气泡显示不全或不对的问题
- 修改会话列表不能展示头像的问题
- 修改ConversationLayout不能修改标题栏颜色的问题
- 支持64位ijkplayer
- 支持多元素消息
## 4.4.900 @2019.08.07

### SDK
**通用变更点**

- 修复某些场景下的稳定性问题
- 优化未读消息计数
- 优化登录后加载最近会话列表速度
- 增加日志清理的功能
- 修复同步大量未读 C2C 消息引起丢消息的问题
- AVChatroom 退群后不再 push 退群系统消息到本设备上
- 修复群系统消息偶现收不到的问题
- onRefresh/onRefreshConversations 回调增加限频逻辑
- 优化 saveMessge 排序异常问题

**iOS & Mac平台**

  - 修改 getGroupInfo 回调参数为 TIMGroupInfoResult，增加获取每个群组对应的错误码
  - 优化 4.x 版本推送展示样式，保持和 2.x，3.x 版本一致
  - 优化登录账号含有中文字符发送图片/文件/视频失败的问题

**Android 平台**

  - 修复4.2.2系统版本的手机加载 so 失败问题
  - 修复 getGroupInfo 接口返回的数据数量不正确问题
  - 修改 getGroupInfo 回调参数为 TIMGroupDetailInfoResult，增加获取每个群组对应的错误码
  - 统一使用com.tencent.imsdk.TIMGroupReceiveMessageOpt类

**Windows平台**

  - 修复Windows配置文件路径为乱码的问题


###  TUIKit & Demo

**iOS**

  - 更改了 iOS Demo 的 UI，包括默认头像、以及输入界面的四个功能图标（拍摄、录像、图片、文件）
  - “我”新加资料卡，将个人信息放入了资料卡中
  - 加入了点击头像查看大图的功能
  - Demo中的群聊小灰条样式改变，用户昵称会变为蓝色，点击昵称可以跳转到用户的信息界面
  - 优化了Demo中群组内昵称的显示逻辑
  - 优化了聊天界面中头像显示的逻辑
  - 在各个界面中添加了触摸反馈，在用户使用TUIKit时可对反馈进行自主设置和定制

**Android**

  - 新增聊天消息语音，MotionEvent.ACTION_CANCEL 事件处理
  - 新增会话列表，聊天界面，详情资料，通讯录，增加头像显示功能
  - 新增个人资料修改头像
  - 新增离线推送功能 Intent 跳转
  - 新增单聊，群聊会话，随机头像
  - 新增群成员被设置成管理员和取消管理员消息提示
  - 新增群成员被禁言和取消禁言消息提示
  - 修复撤回消息后，tips 不显示"您撤回了一条消息"文案
  - 修复撤回消息后，会话列表最后一条消息一直显示撤回消息内容的问题
  - 修复魅族上收到离线消息，进入聊天界面，白屏问题
  - 修复处于置顶会话的聊天会话，收到新消息时，会话不更新最后一条消息问题
  - 修复用户名或密码为空时，Toast 提示
  - 修复群主转让的 GroupTips 消息在 TUIKit 显示异常问题
  - 修复部分手机上报错 Didn't find class "android.support.v4.content.FileProvider"
  - 优化置顶聊天逻辑，按照最近时间排序展示
  - 修复聊天中软键盘和更多布局同时出现问题
  - 修复新注册用户，没有一个好友时，通讯录界面不显示3个 Item（群聊，黑名单，新的联系人）问题
  - 修复播放视频时点击手机返回按钮，视频声音依然在播放问题
  - 修复录制语音消息时，正在播放的语音消息不会停止，会被录制进去问题
  - 修复部分手机播放 iOS 发过来视频播放异常问题



## 4.4.716 @2019.07.16


**iOS & Mac平台**

- API 整理合并
- 文件、视频、语音消息增加获取下载url的接口
- 新增 disableStorage 接口，禁用所有本地存储
- 修复发送在线消息后，发送端 conversation 获取 lastMsg 还能获取到的问题
- getSenderProfile 接口去掉返回值，统一通过回调返回
- 群组的函数 modifyReciveMessageOpt 修改为 modifyReceiveMessageOpt
- 修复 2.X/3.X 版本给 iOS 4.X 版本发视频消息，视频截图拿不到的问题
- 修复退出时数据上报偶现崩溃问题
- 优化登录模块（重复登录/频繁登录/频繁切换账号/自动上线/离线被踢）
- 修复退群/群解散后无法清除未读数问题
- 修复偶现收不到群解散通知问题
- 优化长时间切到后台后再切回前台，发消息耗时长的问题
- 优化单聊未读计数问题
- autoLogin 传参 TIMLoginParam 修改为 userID
- initStorage 传参  TIMLoginParam 修改为 userID
- 去掉多账号同时登陆接口（newManager，getManager，deleteManager）
- 修复 respondsToLocator 偶现崩溃的问题 
- 修复 TIMGroupInfo -> lastMsg 调用相关函数偶现 crash 的问题
- TUIKit
  - 优化最近联系人列表更新算法，减少刷新频率
  - 解决黑名单内存泄漏
  - 新增消息气泡和头像点击事件回调
  - 解决最近联系人与聊天窗口没有显示最新头像问题
  - 优化文档注释

**Android平台**

- 整理与合并 API 接口
  - TIMManager 增加 TIMManagerExt 中的所有接口
  - TIMConversation 增加 TIMConversationExt 中的所有接口
  - TIMGroupManager 增加 TIMGroupManagerExt 中的所有接口
  - TIMMessage 增加 TIMMessageExt 中的所有接口
  - TIMUserConfig 增加 TIMUserConfigMsgExt 中的所有接口
  - 当前保留 TIMManagerExt、TIMMessageExt、TIMConversationExt、TIMGroupManagerExt、TIMUserConfigMsgExt 类原有接口以做兼容，后续这些类将废弃
- 加好友增加单向和双向的选项 
- 新增 disableStorage 接口，禁用所有本地存储
- 文件、视频、语音消息增加获取下载 url 的接口
- 修复部分 android 手机，queryUserProfile 为 null 的问题
- 修复发送在线消息后，发送端 conversation 获取 lastMsg 还能获取到的问题
- getSenderProfile 接口去掉返回值，统一通过回调返回
- 修复退出时数据上报偶现崩溃问题
- 优化登录模块（重复登录/频繁登录/频繁切换账号/自动上线/离线被踢）
- 修复退群/群解散后无法清除未读数问题
- 修复偶现收不到群解散通知问题
- 优化长时间切到后台后再切回前台，发消息耗时长的问题
- 优化单聊未读计数问题
- TUIKit
  - 支持聊天短视频消息，播放时横竖屏旋转
  - 支持 Javadoc 文档
  - 修复发送视频时，正在发送中，下载视频会导致下载失败问题
  - 修复 GroupChatManagerKit.getInstance().sendMessage 方法的 onSuccess 回调会触发两次的问题
  - 优化聊天界面说话太短问题，现在修改为至少为1秒钟，1s以下提示说话太短
  - 修复私有群-邀请成员入群时可以重复邀请同一个成员的问题
  - 处理备注不能设置为空的问题
  - 修复本机系统时间错误后，聊天界面的时间展示异常问题
  - 修复本地发送的语音消息，换一台手机后通过漫游的方式无法下载成功问题
  - 修复群主设置群名称为空时提示修改成功，实际上是修改失败的问题

**Windows平台**

- 修复发送图片、文件、音频、视频等消息包含中文路径，不同终端发送中文问题
- 修复 TIMMsgReportReaded 已读上报无效问题
- 修复收到的消息和消息撤回的 rand 和 seq 不一致问题
- 修复退出时数据上报偶现崩溃问题
- 优化登录模块（重复登录/频繁登录/频繁切换账号/自动上线/离线被踢）
- 修复退群/群解散后无法清除未读数问题
- 修复偶现收不到群解散通知问题
- 优化长时间切到后台后再切回前台，发消息耗时长的问题



## 补丁包 4.4.631 @2019.07.03

**Android平台**

- 修复离线推送问题及崩溃问题



## 4.4.627 @2019.06.27

**iOS & Mac平台**

- 修复无网络时发消息超时长的问题
- 修复消息发送后ID值变化的问题
- 修复消息乱序的问题
- 修复拉取聊天室历史消息丢失的问题
- 修复系统消息类型错误的问题
- 修复获取图片消息的原图片 size 大小为0的问题
- 修复手机修改系统时间后发消息失败问题
- 修复某些情况下上报会话已读失败，获取未读数目异常的问题 
- 修复发送在线消息后，可通过会话 getLastMessage 获取到的问题
- 修复撤回最后一条消息，通过会话获取 lastMsg 状态异常的问题
- 修复消息撤回后，对方的会话列表依然存在消息内容的问题
- 修复断网重连的情况下，图片/语音/文件消息发送状态异常的问题
- 修复登录帐号含有特殊字符，无法发送语音图片的问题
- 修复V2版本向V4版本发图片，V4版本拿不到微缩图宽高的问题
- 修复创建一个会话 saveMessage 后，最近会话拉取不到的问题
- 修复 getMessage 获取不到群Tips消息的 MemberChangeList 内容的问题
- 修复getLoginStatus获取登录状态异常的问题
- 修复拒绝加群请求，对方却进了群的问题
- 修复设置日志路径后，盘符的根目录下也有会一个log文件问题
- 修复互踢收不到回调的问题 -Mac
- TUIKit
  - 优化群组管理页面逻辑
  - 解决iOS 13兼容性问题
  - 已知问题修复

**Android平台**

- 修复无网络时发消息超时长的问题
- 修复消息发送后ID值变化的问题
- 修复消息乱序的问题
- 修复拉取聊天室历史消息丢失的问题
- 修复系统消息类型错误的问题
- 修复下载文件的进度值异常问题
- 修复手机修改系统时间后发消息失败问题
- 修复断网重连的情况下，图片/语音/文件消息发送状态异常的问题
- 修复群组被解散或则用户被禁言后发消息排序异常的问题
- 修复某些情况下上报会话已读失败，获取未读数目异常的问题 
- 修复消息撤回后，对方的会话列表依然存在消息内容的问题
- 修复撤回最后一条消息，通过会话 getLastMessage 状态异常的问题
- 修复发送在线消息后，通过会话 getLastMessage 获取到的问题
- 修复获取图片消息的原图片 size 大小为0的问题
- 修复V2版本向V4版本发图片，V4版本拿不到微缩图宽高的问题
- 修复被挤下线后 getLoginUser() 仍可获取登录的用户问题
- 修复 getSenderProfile 获取个人信息为空的问题
- 修复群系统消息 TIMGroupSystemElem 中的 getOpUser 为空的问题
- 修复 getMessage 获取不到群Tips消息的 MemberChangeList 内容的问题
- 修复创建一个会话 saveMessage 后，最近会话拉取不到的问题
- 修复设置日志路径后，盘符的根目录下也有会一个log文件问题

- TUIKit
  - 已知问题修复

**Windows平台**

- 修复无网络时发消息超时长的问题
- 修复消息发送后ID值变化的问题
- 修复消息乱序的问题
- 修复拉取聊天室历史消息丢失的问题
- 修复系统消息类型错误的问题
- 修复跨平台库iOS的ImSDK模块中不包含Armv7a架构的问题
- 修复跨平台库TIMMsgReportReaded接口不支持Message为空的问题
- 修复跨平台库同一设备下运行IM多个实例登录同一个帐号不互踢问题
- 跨平台库消息增加获取消息唯一ID的json key
- 修复设置日志路径后，盘符的根目录下也有会一个log文件问题
- 修复 getMessage 获取不到群Tips消息的 MemberChangeList 内容的问题
- 修复撤回最后一条消息，通过会话获取 lastMsg 状态异常的问题
- 修复某些情况下上报会话已读失败，获取未读数目异常的问题



## 4.4.479 @2019.06.12

**iOS平台**

- 修复拉取离线消息出现丢消息的问题
- 修复更换不同 SDKAppId 引起登录失败的问题
- 修复语音消息播放失败的问题
- 修复群消息撤回的崩溃
- 修复获取好友列表和创建群组的6002错误
- 优化发送消息的效率
- 缓存优化，降低UI卡顿
- TUIKit
  - 全新的UI设计
  - 全新的架构设计
  - 完善通讯录、群组管理、关系链等功能
  - 一大波bugfix

**Android平台**

- 修复拉取离线消息出现丢消息的问题
- 修复更换不同 SDKAppId 引起登录失败的问题
- 修复语音消息播放失败的问题
- 修复群消息撤回的崩溃
- 修复获取好友列表和创建群组的6002错误
- 修复Android 创建群人数过多导致崩溃问题
- 优化发送消息的效率
- 缓存优化，降低UI卡顿
- TUIKit
  - 全新的UI设计
  - 全新的架构设计
  - 完善通讯录、群组管理、关系链等功能
  - 一大波bugfix

**Windows平台**

- 修复拉取离线消息出现丢消息的问题
- 修复更换不同 SDKAppId 引起登录失败的问题
- 修复语音消息播放失败的问题
- 修复群消息撤回的崩溃
- 修复获取好友列表和创建群组的6002错误
- 缓存优化，降低UI卡顿
- 优化发送消息的效率


## 4.3.145 @2019.05.31

**iOS平台**

- 修复切换账号后再次收到同样的消息问题
- 修复票据过期后获取c2c漫游消息崩溃问题
- 修复 ChatRoom 群新用户加入后获取不到历史消息问题
- 修复 FindMsg 崩溃问题
- 优化群消息同步问题
- 修复 getReciveMessageOpt 偶现异常


**Android平台**

- 修复切换账号后再次收到同样的消息问题
- 修复票据过期后获取c2c漫游消息崩溃问题
- 修复 ChatRoom 群新用户加入后获取不到历史消息问题
- 避免重复添加相同的消息监听器
- 修复 FindMsg 崩溃问题
- 优化群消息同步问题

**Windows平台**

- 修复切换账号后再次收到同样的消息问题
- 修复票据过期后获取c2c漫游消息崩溃问题
- 修复 ChatRoom 群新用户加入后获取不到历史消息问题
- 优化群消息同步问题




## 4.3.135 @2019.05.24

**iOS平台**

- 增加校验好友接口 checkFriends
- 增加 queryGroupInfo 接口获取本地数据
- 废弃 getGroupPublicInfo 接口，统一用 getGroupInfo 接口
- 修复消息列表包含已删除消息的问题
- 修复未登陆获取不了本地消息问题
- 修复最近联系人拉取数量及排序问题
- 修复群消息断网重连后的消息同步问题
- 修复短时间内接收大量消息时判重失效问题
- 修复重启程序后有概率再次收到同一条消息的问题
- 修复初始化和同步消息偶现异常问题
- 修复会话的 lastMsg 被删除引发的偶现异常问题
- 修复登录后 onRefreshConversation 回调两次且数据相同问题
- 修复 chatroom 获取不了入群前的历史消息问题
- 修复 TIMMessage 的 copyFrom 接口不生效的问题
- 修复 TIMGroupEventListener 监听收不到回调的问题
- 修复线上反馈的 Crash 问题
- 优化重连时连接请求
- 优化在不同网络下首次连接和海外接入点的质量
- 优化iOS切换WIFI时网络重连慢的问题


**Android平台**

- 增加校验好友接口 checkFriends
- 增加 queryGroupInfo 接口获取本地数据
- 废弃 getGroupDetailInfo 和 getGroupPublicInfo 接口，统一用 getGroupInfo 接口
- 修复消息列表包含已删除消息的问题
- 优化 modifyGroupOwner 和 getGroupMembersByFilter 回调问题
- 修复未登陆获取不了本地消息问题
- 修复最近联系人拉取数量及排序问题
- 修复群消息断网重连后的消息同步问题
- 修复短时间内接收大量消息时判重失效问题
- 修复重启程序后有概率再次收到同一条消息的问题
- 修复初始化和同步消息偶现异常问题
- 修复会话的 lastMsg 被删除引发的偶现异常问题
- 修复登录后 onRefreshConversation 回调两次且数据相同问题
- 修复 chatroom 获取不了入群前的历史消息问题
- 修复线上反馈的 Crash 问题
- 优化重连时连接请求
- 优化在不同网络下首次连接和海外接入点的质量



**Windows平台**

- 新增自定义字段数据上报
- 新增阅后即焚消息
- 新增消息撤回使用用例
- 修复设置上传文件偶现失败问题
- 修复消息列表包含已删除消息的问题
- 修复最近联系人拉取数量及排序问题
- 修复群消息断网重连后的消息同步问题
- 修复短时间内接收大量消息时判重失效问题
- 修复重启程序后有概率再次收到同一条消息的问题
- 修复会话的 lastMsg 被删除引发的偶现异常问题
- 修复初始化和同步消息偶现异常问题
- 发送消息，在发送成功的回调里面返回消息的json字符串
- TIMSetRecvNewMsgCallback 接口改为 TIMAddRecvNewMsgCallback 和 TIMRemoveRecvNewMsgCallback 接口
- 新增socks5代理服务器配置
- 优化重连时连接请求
- 优化在不同网络下首次连接和海外接入点的质量



## 4.3.118 @2019.05.10

**iOS平台**

- 增加 TIMFriendshipManager 类中的 querySelfProfile 和 queryUserProfile 接口（读取本地数据）
- 修复获取登录 getLoginUser 返回登录用户异常的问题
- 修复线上反馈的用户资料获取失败问题
- 修复重启 APP 后部分本地字段失效问题
- 修复消息删除后调用已读上报偶现异常的问题
- 修复线上反馈的 IM 群组问题
- 修复会话未读数问题
- 修复在线消息问题
- 修复消息重发偶现失效问题
- 修复本地票据过期导致持续重连问题
- 修复线上反馈的 Crash 问题
- 优化服务器连接策略
- 优化断网重连策略
- 优化服务器过载策略
- 优化心跳，减少不必要发包
- TUIKit 
  - 新增支持 CocoaPods 导入
  - 新增联系人界面
  - 新增好友添加界面
  - 新增黑名单界面
  - 新增好友搜索界面
  - 新增新朋友界面
  - 优化好友资料页：增加备注、黑名单、删除好友功能
  - 优化个人资料页：增加昵称、个人签名、生日、性别、所在地修改功能
  - 优化群列表置顶功能

**Android平台**

- 增加 TIMFriendshipManager 类中的 querySelfProfile 和 queryUserProfile 接口（读取本地数据）
- 增加获取好友信息中 addTime 字段
- 增加 x86 及 x86_64 架构支持
- 修复获取登录 getLoginUser 返回登录用户异常的问题
- 修复线上反馈的用户资料获取失败问题
- 修复重启 APP 后部分本地字段失效问题
- 修复消息删除后调用已读上报偶现异常的问题
- 修复线上反馈的 IM 群组问题
- 修复会话未读数问题
- 修复在线消息问题
- 修复消息重发偶现失效问题
- 修复本地票据过期导致持续重连问题
- 修复线上反馈的 Crash 问题
- 优化服务器连接策略
- 优化断网重连策略
- 优化服务器过载策略
- 优化心跳，减少不必要发包
- TUIKit 
  - 加入聊天置顶功能
  - 修改昵称和个性签名，资料页面显示昵称
  - 修复 Android 端接收到 iOS 端发送的表情包后无法显示出来问题
  - 修复未读消息红点数问题
  - 修复美图 M8 设备点击加号后显示操作界面有 UI 问题
  - 修复设置头像后，头像会被缩小，不能铺满 UI 问题
  - 修复登录，自动登录逻辑
  - 修复超过输入内容最大限制后导致的 ANR 问题 
  - 修复发送图片, 当在相册选择图片并预览模式的时候，点击【确定】，发送会没有反应问题
  - 修复聊天界面长按图片消息没有弹出删除和撤销的操作按钮
  - 优化和修复线上反馈的 crash 问题

**Windows平台**

- 修复获取登录 getLoginUser 返回登录用户异常的问题
- 修复线上反馈的用户资料获取失败问题
- 修复重启 APP 后部分本地字段失效问题
- 修复消息删除后调用已读上报偶现异常的问题
- 修复线上反馈的 IM 群组问题
- 修复会话未读数问题
- 修复在线消息问题
- 修复消息重发偶现失效问题
- 修复本地票据过期导致持续重连问题
- 修复线上反馈的 Crash 问题
- 优化服务器连接策略
- 优化断网重连策略
- 优化服务器过载策略
- 优化心跳，减少不必要发包



## 4.3.81 @2019.04.24

**新功能**
- Android平台 补齐老版本 SDK 的好友黑名单功能，好友分组功能，以及加好友请求处理等关系链功能。

**iOS平台**
- 修复草稿箱添加消息元素crash的问题
- 修复某些账户在app卸载重装后拉取不到会话列表的问题
- 修复在登录的状态下usersig过期，不重启app的情况下会一直登录失败的问题
- 修复在登录的状态下usersig过期，发消息失败，收不到 usersig 过期回调的问题
- 修复修复群成员获取数量问题
- 优化请求超时（错误码6012）问题

**Android平台**
- 修复一处app主进程被杀后的报错问题
- 修复群成员获取数量问题
- 修复群自定义字段和群成员自定义字段的设置和获取问题
- 修复获取群信息超时后，没有onError回调出去的问题
- 修复某些账户在app卸载重装后拉取不到会话列表的问题
- 修复在登录的状态下usersig过期，不重启app的情况下会一直登录失败的问题
- 修复在登录的状态下usersig过期，发消息失败，收不到 usersig 过期回调的问题
- 修复消息乱序问题
- 优化请求超时（错误码6012）问题
- 更新关系链错误码
- TUIKit修复日期工具类出错的严重bug(github issue#75)
- TUIKit修改一处崩溃(github issue#86)
- TUIKit修复无权限时，使用SDK的一些问题
- TUIKit修复删除会话，删除消息，然后长按后的一些崩溃问题
- TUIKit修复popupwindow长驻不消失问题
- TUIKit修复消息重复问题
- TUIKit拦截发送空格空消息问题
- TUIKit修复删除会话后，未读消息未更新问题
- TUIKit修复发送消息最大字符限制问题
- TUIKit体验优化和修复若干数组越界问题

**Windows平台**
- 修复部分崩溃问题
- 优化请求超时（错误码6012）问题
- 修复某些账户在app卸载重装后拉取不到会话列表的问题
- 修复在登录的状态下usersig过期，不重启app的情况下会一直登录失败的问题
- 修复在登录的状态下usersig过期，发消息失败，收不到 usersig 过期回调的问题



## 4.2.52 @2019.04.17

**新功能**

- 补齐老版本 SDK 的好友黑名单功能，好友分组功能，以及加好友请求处理等关系链功能。

**iOS平台**
- 优化 API 接口注释
- 修复群自定义字段和群成员自定义字段不生效的问题
- 优化 TIMMessage 获取 senderProfile 拿不到用户资料信息的问题
- 修复已读回执回调及状态问题
- 修复同步未读消息最新一条消息不回调问题
- 修复群消息偶尔收不到问题
- 修复login回包无法解密问题
- 增加ip连接和login信息统计上报
- 修复消息seq错误

**Android平台**
- 修复android的jni泄漏
- 修复群组成员角色错误问题
- 修复退群在加群后，群组消息撤回崩溃问题
- 修复TUIKit Demo表情不显示问题
- 修复群聊会话获取消息，第二页大概率获取重复消息问题
- 修复TUIKit Demo中的部分crash问题
- 优化 TIMMessage 获取 senderProfile 拿不到用户资料信息的问题
- 修复已读回执回调及状态问题
- 修复同步未读消息最新一条消息不回调问题
- 修复群消息偶尔收不到问题
- 修复login回包无法解密问题
- 增加ip连接和login信息统计上报
- 修复消息seq错误

**Windows平台**
- 优化 TIMMessage 获取 senderProfile 拿不到用户资料信息的问题
- 修复已读回执回调及状态问题
- 修复同步未读消息最新一条消息不回调问题
- 修复群消息偶尔收不到问题
- 修复login回包无法解密问题
- 增加ip连接和login信息统计上报
- 修复消息seq错误



## 4.2.28 @2019.04.08

### iOS：

**bugfix：**

- 优化未读计数相关的问题
- 优化消息已读状态的问题
- 优化RESTAPI发的C2C消息排序异常的问题
- 优化获取漫游消息偶现重复的问题
- 优化uniqueId空实现的问题

### Android：

**新增：**

- 新增好友增/删/查逻辑


**bugfix：**

- 优化未读计数相关的问题

- 优化消息已读状态的问题
- 优化RESTAPI发的C2C消息排序异常的问题
- 优化获取漫游消息偶现重复的问题
- 优化uniqueId空实现的问题

### Windows：

**bugfix：**

- 优化未读计数相关的问题
- 优化消息已读状态的问题
- 优化RESTAPI发的C2C消息排序异常的问题
- 优化获取漫游消息偶现重复的问题

## 4.2.10 @2019.03.29

### iOS：
**新增：**

-    新增好友增/删/查逻辑


**bugfix：**

  - 优化超时问题
  - 优化自动登录逻辑
  - 优化crash问题
  - 优化偶现网络连接异常bug

### Android：

**bugfix：**

 - 优化超时问题
 - 优化自动登录逻辑
 - 优化JNI泄漏问题
 - 优化crash问题
 - 优化偶现网络连接异常bug

### Windows：

**bugfix：**

  - 优化超时问题
  - 优化crash问题
  - 优化偶现网络连接异常bug

## 4.2.9 @2019.03.27

### iOS & Mac：

**bugfix：**

- 修复ipv6环境下crash的问题
- 修复资料设置整数失败的问题

### Android：

**bugfix：**

- 修复资料设置整数失败的问题

## 4.2.1 @2019.03.15

### iOS:

- 调整项 优化后台解散群组, 客户端收不到相应指令的问题
- 修复项 调用 deleteConversationAndMessage() 无效
- 修复项 优化网络重新连接后收不到消息的问题 (现在网络重新连接后可以在会话界面主动请求拉取消息了)

### Android:

- 修复项 群组获取未决和已决信息返回不正确
- 修复项 客户端进入后台 Crash (现在 APP 进入后台不会直接 Crash 了)
- 修复项 优化网络重新连接后收不到消息的问题 (现在网络重新连接后可以在会话界面主动请求拉取消息了)
- 修复项 偶现消息排序错误
- 修复项 偶现消息发送失败

### WEB:

- 新增项 WEBIM 现已支持播放 .amr 的录音格式

### Windows:

- 新增项 /source-charset:.65001 编译选项
- 修复项 在文件系统直接运行 IMAPP.exe Crash 问题
- 修复项 部分编译出错, 以及 Crash 问题
- 移除项 X64 编译 (暂不支持)

## 4.0.13 @2019.03.13

### Android:

- 修复项 从 3.x 升级到 4.x 版本后登陆引起 Crash 的问题

### iOS:

- 新增项 支持 pod 直接集成 TUIKit.framework
- 修复项 从 3.x 升级到 4.x 版本后登陆引起 Crash 的问题

### Windows:

- 新增项 以 duilib 库为 UI 组件的 IM Demo
- 新增项 使用说明及相关集成指引文档

## 4.0.12 @2019.03.08
### Android:

- 修复项 群组禁言无效问题
- 修复项 修改用户群内身份功能
- 修复项 修改群消息接收选项
- 修复项 离线推送开关无效问题

### iOS:

- 新增项 TUIKit.framework 支持 bitcode 2
- 修复项 群组禁言无效问题
- 修复项 修改用户群内身份功能


## 4.0.10版本(Android端)

- 修复AVChatRoom进入房间超过100人之后收消息异常的问题

## 4.0.7版本

- 修复新老版本语音，文件，视频消息互通的问题
- 解决-5 tls exchange failed 卸载应用重新安装才能登录成功

## 4.0.6版本

- 解决userSig过期后重签仍然登陆失败问题

## 4.0.4版本

- 解决userSig过期后再次登录返回错误码不正确问题，应该返回6206；优化互踢逻辑

## 4.0.3版本

- 修复第三方离线推送问题
